<template>
  <div>
    <base-breadcrumbs v-once :titles="createCrumbs" />

    <main class="category-wrapper">
      <div class="container">
        <div class="grid">
          <div class="one">
            <div class="category-image">
              <img
                :src="currentCategory.detail_img"
                :alt="currentCategory.title"
              />
            </div>
          </div>
          <div class="two">
            <div class="category-title">
              <h2>{{ currentCategory.name }}</h2>
            </div>
          </div>
          <div class="three">
            <div class="category-description">
              <p>{{ currentCategory.description }}</p>
            </div>
          </div>
        </div>
      </div>
    </main>

    <div class="container">
      <div class="content">
        <div class="row">
          <div class="col-md-4 col-lg-3 d-flex flex-column">
            <base-input
              v-model="controls.search"
              :request-tips="
                (term) => $store.dispatch('products/onSearch', term)
              "
              component="search"
              class="d-flex d-md-none mb-3"
              placeholder="Поиск"
              @change="(search) => appendQuery({ search, page: '' })"
            />
            <accordion-filter
              id="accordion-filter-1"
              :open="!categories.length"
              @submit="(filters) => appendQuery({ ...filters, page: '' })"
              @clear="$router.push({ query: {} })"
            />
            <category-list
              :categories="categories"
              class="list-unstyled d-none d-md-block"
            />
          </div>
          <div class="col-md-8 col-lg-9">
            <div class="row">
              <dropdown-sort
                v-once
                class="btn-group mb-5 mb-md-0 col-6 col-md-4 col-lg-6"
              />
              <div
                class="d-none d-md-block mb-3 mb-md-0 col-12 col-md-7 col-lg-4 offset-md-1 offset-lg-2"
              >
                <base-input
                  v-model="controls.search"
                  :request-tips="
                    (term) => $store.dispatch('products/onSearch', term)
                  "
                  component="search"
                  placeholder="Поиск"
                  @change="(search) => appendQuery({ search, page: '' })"
                />
              </div>
              <div
                class="d-flex justify-content-end mb-5 col-6 col-md-12 mt-0 mt-md-4"
              >
                <a
                  href="#mapModal"
                  data-toggle="modal"
                  @click.prevent="openPopup"
                  >Показать на карте</a
                >
              </div>
            </div>

            <div class="product-list row">
              <div
                v-for="product in productItems.results"
                :key="product.id"
                class="col-6 col-lg-4"
              >
                <product-card v-bind="product" />
              </div>
            </div>

            <base-pagination :total-pages="productItems.count_pages" />
          </div>
        </div>
      </div>
      <related-content
        :key="currentCategory.id"
        :slides="slick.slides"
        base-link="category"
      />
    </div>
    <popup-map v-if="currentPopup" :items="productItems.results" />
  </div>
</template>

<script>
import { mapState } from 'vuex'
import {
  TypesCategories,
  TypesPopup,
  TypesGlobal,
} from '@/constants/store.types'
import { fetch } from '@/mixins/product'
import { MAP } from '@/constants/popups'

import AccordionFilter from '@/components/controls/AccordionFilter.vue'
import DropdownSort from '@/components/controls/DropdownSort.vue'
const PopupMap = () => import('@/components/popups/PopupMap.vue')

export default {
  name: 'CategoryPage',
  components: {
    AccordionFilter,
    DropdownSort,
    PopupMap,
  },
  mixins: [fetch],
  validate({ params, store }) {
    return params.pathMatch
      .split('/')
      .every((path) =>
        store.getters[TypesCategories.getters.HAS_CATEGORY](path)
      )
  },
  data() {
    return {
      currentCategory: {},
      controls: {
        search: '',
      },
      slick: {
        settings: {},
        slides: [],
      },
    }
  },
  async fetch() {
    const category =
      this.$store.state.categories.map[
        this.$route.params.pathMatch.split('/').pop()
      ]
    this.$axios
      .$get(`/categories/${category.id}/`)
      .then(
        (responseCategory) =>
          (this.currentCategory = { ...category, ...responseCategory })
      )
      .catch(console.error)
    this.slick.slides = (
      await this.$axios.$get('/categories/recommendations/')
    ).results
    this.$store.commit(
      TypesGlobal.mutations.SET_TITLE,
      this.currentCategory.name
    )
  },
  head() {
    return {
      title: this.currentCategory.name,
    }
  },
  computed: {
    ...mapState('popup', {
      currentPopup: (state) => state.currentPopup === MAP,
    }),
    categories() {
      return this.currentCategory.children || []
    },
  },
  methods: {
    openPopup() {
      this.$store.commit(TypesPopup.mutations.OPEN_POPUP, MAP)
    },
    createCrumbs(match) {
      return this.$store.state.categories.map[
        match.params.pathMatch.split('/').pop()
      ].name
    },
  },
}
</script>
